# XmlPropertyTask

Extends \PropertyTask

Task for setting properties from an XML file in buildfiles.

Use \Project#createTask to register a new Task.

author | Jonathan Bond-Caron jbondc@openmv.com
version | $Id: d9741f5e9084e1c59c5dfeb32524d56fe052ecfc $
package | phing.tasks.ext
since | 2.4.0
link | http://ant.apache.org/manual/CoreTasks/xmlproperty.html

### Methods

## Adds an XML node

    _addNode(\SimpleXMLElement $node, array $path, \Properties $prop) : void

### Arguments

#### $node

`\SimpleXMLElement`

#### $path

`array`

Path to this node

#### $prop

`\Properties`

Properties will be added as they are found (by reference here)

## Parses an XML file and returns properties

    _getProperties(string $filePath) : \Properties

throws |

### Arguments

#### $filePath

`string`

### Response

`\Properties`

## iterate through a set of properties, resolve them then assign them

    addProperties( $props)

inherited

throws |

### Arguments

#### $props

``

## add a name value pair to the project property set

    addProperty(string $name, string $value)

inherited

### Arguments

#### $name

`string`

name of property

#### $value

`string`

value to set

## Creates a filterchain

    createFilterChain() : object

inherited

### Response

`object`

The created filterchain object

## getCollapseAttributes

    getCollapseAttributes() : boolean

### Response

`boolean`

## getDelimiter

    getDelimiter() : string

### Response

`string`

## Returns the textual description of the task

    getDescription() : string

inherited

### Response

`string`

The text description of the task

## getEnvironment

    getEnvironment()

inherited

## getFallback

    getFallback()

inherited

## Get the PhingFile that is being used as property source.

    getFile()

inherited

## getKeepRoot

    getKeepRoot() : boolean

### Response

`boolean`

## Returns the location within the buildfile this task occurs. Used by {@link BuildException} to give detailed error messages.

    getLocation() : \Location

inherited

### Response

`\Location`

The location object describing the position of this task within the buildfile.

## getLogoutput

    getLogoutput() : boolean

inherited

### Response

`boolean`

## Get property component name.

    getName()

inherited

## getOverride

    getOverride() : boolean

inherited

### Response

`boolean`

## Returns the owning target of this task.

    getOwningTarget() : \Target

inherited

### Response

`\Target`

The target object that owns this task

## getPrefix

    getPrefix() : string

inherited

since | 2.0

### Response

`string`

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## getRefid

    getRefid()

inherited

## Returns a name

    getRegisterSlot(string $slotName) : \RegisterSlot

inherited

### Arguments

#### $slotName

`string`

### Response

`\RegisterSlot`

## getRequired

    getRequired() : string

### Response

`string`

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

inherited

### Response

`\RuntimeConfigurable`

The wrapper object used by this task

## Returns the name of task, used only for log messages

    getTaskName() : string

inherited

### Response

`string`

Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

inherited

### Response

`string`

The type of this task (XML Tag)

## getUserProperty

    getUserProperty() : boolean

inherited

### Response

`boolean`

## Get the value of current property component.

    getValue()

inherited

## Called by the parser to let the task initialize properly.

    init()

inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

throws |

## load the environment values

    loadEnvironment(string $prefix)

inherited

### Arguments

#### $prefix

`string`

prefix to place before them

## load properties from a file.

    loadFile(\PhingFile $file)

inherited

throws |

### Arguments

#### $file

`\PhingFile`

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Called by the project to let the task do it's work. This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running <em>phing target1 target2</em> will run all tasks in target3 twice.

    main()

inherited abstract

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

## Configure this task if it hasn't been done already.

    maybeConfigure()

inherited

## This method will parse a string containing ${value} style property values into two lists. The first list is a collection of text fragments, while the other is a set of string property names null entries in the first list indicate a property reference from the second list.

    parsePropertyString(string $value,  &$fragments,  &$propertyRefs)

inherited

This is slower than regex, but useful for this class, which has to handle multiple parsing passes for properties.

throws |

### Arguments

#### $value

`string`

The string to be scanned for property references

#### $fragments

``

#### $propertyRefs

``

## Perfrom this task

    perform()

inherited

throws |

## Given a Properties object, this method goes through and resolves any references to properties within the object.

    resolveAllProperties(\Properties $props) : void

inherited

throws |

### Arguments

#### $props

`\Properties`

The collection of Properties that need to be resolved.

## Treat attributes as nested elements.

    setCollapseAttributes(boolean $yesNo)

### Arguments

#### $yesNo

`boolean`

## Delimiter for splitting multiple values.

    setDelimiter(string $d)

### Arguments

#### $d

`string`

## Sets a textual description of the task

    setDescription(string $desc)

inherited

### Arguments

#### $desc

`string`

The text describing the task

## setFallback

    setFallback(\Project $p)

inherited

### Arguments

#### $p

`\Project`

## Set a file to use as the source for properties.

    setFile( $file)

inherited

### Arguments

#### $file

``

## Keep the xml root tag as the first value in the property name

    setKeepRoot(boolean $yesNo)

### Arguments

#### $yesNo

`boolean`

## Sets the location within the buildfile this task occurs. Called by the parser to set location information.

    setLocation(\Location $location)

inherited

### Arguments

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## setLogoutput

    setLogoutput( $logOutput)

inherited

### Arguments

#### $logOutput

``

## Sets a the name of current property component

    setName( $name)

inherited

### Arguments

#### $name

``

## setOverride

    setOverride( $v)

inherited

### Arguments

#### $v

``

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

inherited

### Arguments

#### $target

`\Target`

## Prefix to apply to properties loaded using <code>file</code>.

    setPrefix(string $prefix) : void

inherited

A "." is appended to the prefix if not specified.

since | 2.0

### Arguments

#### $prefix

`string`

prefix string

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## setRefid

    setRefid(\Reference $ref)

inherited

### Arguments

#### $ref

`\Reference`

## File required or not.

    setRequired(string $d)

### Arguments

#### $d

`string`

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

inherited

### Arguments

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## Sets the name of this task for log messages

    setTaskName(string $name) : string

inherited

### Arguments

#### $name

`string`

### Response

`string`

A string representing the name of this task for log

## Sets the type of the task. Usually this is the name of the XML tag

    setTaskType( $name)

inherited

### Arguments

#### $name

``

## Set whether this is a user property (ro).

    setUserProperty(boolean $v)

inherited

This is deprecated in Ant 1.5, but the userProperty attribute of the class is still being set via constructor, so Phing will allow this method to function.

### Arguments

#### $v

`boolean`

## Sets a the value of current property component.

    setValue( $value)

inherited

### Arguments

#### $value

``

## toString

    toString() : string

inherited

### Response

`string`

### Properties

## _keepRoot

    _keepRoot :

### Type(s)

``

## _collapseAttr

    _collapseAttr :

### Type(s)

``

## _delimiter

    _delimiter :

### Type(s)

``

## _required

    _required :

### Type(s)

``

## name of the property

    name :

inherited

### Type(s)

``

## value of the property

    value :

inherited

### Type(s)

``

## reference

    reference :

inherited

### Type(s)

``

## env

    env :

inherited

### Type(s)

``

## file

    file :

inherited

### Type(s)

``

## ref

    ref :

inherited

### Type(s)

``

## prefix

    prefix :

inherited

### Type(s)

``

## fallback

    fallback :

inherited

### Type(s)

``

## Whether to force overwrite of existing property.

    override :

inherited

### Type(s)

``

## Whether property should be treated as "user" property.

    userProperty :

inherited

### Type(s)

``

## All filterchain objects assigned to this task

    filterChains :

inherited

### Type(s)

``

## Whether to log messages as INFO or VERBOSE

    logOutput :

inherited

### Type(s)

``

## Owning Target object

    target : \Target

inherited

var |

### Type(s)

`\Target`

## Description of the task

    description : string

inherited

var |

### Type(s)

`string`

## Internal taskname (req)

    taskType : string

inherited

var |

### Type(s)

`string`

## Taskname for logger

    taskName : string

inherited

var |

### Type(s)

`string`

## Stored buildfile location

    location : \Location

inherited

var |

### Type(s)

`\Location`

## Wrapper of the task

    wrapper : \RuntimeConfigurable

inherited

var |

### Type(s)

`\RuntimeConfigurable`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`